'use strict';var cov_1y2pchzif8 = function () {var path = '/home/smcintyre/workspace/ravel-framework/ravel/lib/core/decorators/mapping.js',hash = '5b04726c990a4c8e0c6e3644a5d3d4c87633e200',global = new Function('return this')(),gcv = '__coverage__',coverageData = { path: '/home/smcintyre/workspace/ravel-framework/ravel/lib/core/decorators/mapping.js', statementMap: { '0': { start: { line: 3, column: 17 }, end: { line: 3, column: 43 } }, '1': { start: { line: 4, column: 18 }, end: { line: 4, column: 50 } }, '2': { start: { line: 48, column: 2 }, end: { line: 71, column: 4 } }, '3': { start: { line: 50, column: 4 }, end: { line: 69, column: 5 } }, '4': { start: { line: 52, column: 6 }, end: { line: 52, column: 25 } }, '5': { start: { line: 53, column: 19 }, end: { line: 58, column: 7 } }, '6': { start: { line: 59, column: 6 }, end: { line: 59, column: 94 } }, '7': { start: { line: 62, column: 19 }, end: { line: 67, column: 7 } }, '8': { start: { line: 68, column: 6 }, end: { line: 68, column: 68 } }, '9': { start: { line: 77, column: 0 }, end: { line: 77, column: 25 } } }, fnMap: { '0': { name: 'mapping', decl: { start: { line: 47, column: 9 }, end: { line: 47, column: 16 } }, loc: { start: { line: 47, column: 51 }, end: { line: 72, column: 1 } }, line: 47 }, '1': { name: '(anonymous_1)', decl: { start: { line: 48, column: 9 }, end: { line: 48, column: 10 } }, loc: { start: { line: 48, column: 44 }, end: { line: 71, column: 3 } }, line: 48 } }, branchMap: { '0': { loc: { start: { line: 50, column: 4 }, end: { line: 69, column: 5 } }, type: 'if', locations: [{ start: { line: 50, column: 4 }, end: { line: 69, column: 5 } }, { start: { line: 50, column: 4 }, end: { line: 69, column: 5 } }], line: 50 }, '1': { loc: { start: { line: 52, column: 13 }, end: { line: 52, column: 24 } }, type: 'binary-expr', locations: [{ start: { line: 52, column: 13 }, end: { line: 52, column: 17 } }, { start: { line: 52, column: 21 }, end: { line: 52, column: 24 } }], line: 52 }, '2': { loc: { start: { line: 56, column: 16 }, end: { line: 56, column: 73 } }, type: 'cond-expr', locations: [{ start: { line: 56, column: 39 }, end: { line: 56, column: 45 } }, { start: { line: 56, column: 48 }, end: { line: 56, column: 73 } }], line: 56 } }, s: { '0': 0, '1': 0, '2': 0, '3': 0, '4': 0, '5': 0, '6': 0, '7': 0, '8': 0, '9': 0 }, f: { '0': 0, '1': 0 }, b: { '0': [0, 0], '1': [0, 0], '2': [0, 0] }, _coverageSchema: '332fd63041d2c1bcb487cc26dd0d5f7d97098a6c' },coverage = global[gcv] || (global[gcv] = {});if (coverage[path] && coverage[path].hash === hash) {return coverage[path];}coverageData.hash = hash;return coverage[path] = coverageData;}();

const Metadata = (cov_1y2pchzif8.s[0]++, require('../../util/meta'));
const httpCodes = (cov_1y2pchzif8.s[1]++, require('../../util/http_codes'));

/**
                                                                              * The `@mapping` decorator for `Routes` classes. Indicates that
                                                                              * the decorated method should be mapped as a route handler using `koa`.
                                                                              *
                                                                              * Can also be applied at the class-level to indicate routes which do
                                                                              * nothing except return a particular status code.
                                                                              *
                                                                              * @param {symbol} verb - An HTTP verb such as `Routes.GET`, `Routes.POST`, `Routes.PUT`, or `Routes.DELETE`.
                                                                              * @param {string} path - The path for this endpoint, relative to the base path of the Routes class.
                                                                              * @param {(number | undefined)} status - A status to always return, if this is applied at the class-level.
                                                                              *                               If applied at the method-level, then the method will be used as a handler instead.
                                                                              * @param {(boolean | undefined)} suppressLog - Don't log a message describing this endpoint iff true.
                                                                              * @example
                                                                              * const Routes = require('ravel').Routes;
                                                                              * const mapping = Routes.mapping;
                                                                              *
                                                                              * class MyRoutes extends Routes {
                                                                              *   constructor () {
                                                                              *     super('/');
                                                                              *   }
                                                                              *
                                                                              *   // will map to /projects
                                                                              *   // &#64;mapping(Routes.GET, 'projects')
                                                                              *   async handler (ctx) {
                                                                              *     // ctx is a koa context object
                                                                              *   }
                                                                              * }
                                                                              * @example
                                                                              * const Ravel = reuqire('ravel');
                                                                              * const Routes = Ravel.Routes;
                                                                              * const mapping = Routes.mapping;
                                                                              *
                                                                              * // class-level version will create a route '/' which responds with 501 in this case
                                                                              * // &#64;mapping(Routes.DELETE, 'projects', Ravel.httpCodes.NOT_IMPLEMENTED)
                                                                              * class MyRoutes extends Routes {
                                                                              *   constructor (bodyParser) {
                                                                              *     super('/');
                                                                              *     this.bodyParser = bodyParser();
                                                                              *   }
                                                                              * }
                                                                              */
function mapping(verb, path, status, suppressLog) {cov_1y2pchzif8.f[0]++;cov_1y2pchzif8.s[2]++;
  return function (target, key, descriptor) {cov_1y2pchzif8.f[1]++;cov_1y2pchzif8.s[3]++;
    // TODO ensure this is only used on Routes classes
    if (key === undefined) {cov_1y2pchzif8.b[0][0]++;cov_1y2pchzif8.s[4]++;
      // class-level
      path = (cov_1y2pchzif8.b[1][0]++, path) || (cov_1y2pchzif8.b[1][1]++, '/');
      const info = (cov_1y2pchzif8.s[5]++, {
        verb: verb,
        path: path,
        status: status !== undefined ? (cov_1y2pchzif8.b[2][0]++, status) : (cov_1y2pchzif8.b[2][1]++, httpCodes.NOT_IMPLEMENTED),
        suppressLog: suppressLog });cov_1y2pchzif8.s[6]++;

      Metadata.putClassMeta(target.prototype, '@mapping', verb.toString() + ' ' + path, info);
    } else {cov_1y2pchzif8.b[0][1]++;
      // method-level
      const info = (cov_1y2pchzif8.s[7]++, {
        verb: verb,
        path: path,
        endpoint: descriptor.value,
        suppressLog: suppressLog });cov_1y2pchzif8.s[8]++;

      Metadata.putMethodMeta(target, key, '@mapping', 'info', info);
    }
    // delete target[key]
  };
}

/*!
   * Export `@mapping` decorator
   */cov_1y2pchzif8.s[9]++;
module.exports = mapping;